 ;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;  SoundBlaster test  ;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;

 macro	dsp_w	bport, value, err_jmp {
	mov	dx, bport
	add	dx, 0Ch
	mov	cx, 100
 @@:
	in	al, dx
	and	al, 80h
	jz	.wready
	loop	@b
	jmp	err_jmp
 .wready:
	mov	al, value
	out	dx, al
 }

 macro	dsp_r	bport, err_jmp {
	mov	dx, bport
	add	dx, 0Eh
	mov	cx, 100
 @@:
	in	al, dx
	and	al, 80h
	jnz	.rready
	loop	@b
	jmp	err_jmp
 .rready:
	sub	dx, 4
	in	al, dx
 }

 use16
 org		100h
 begin:
	;  
	mov	ah, 9
	mov	dx, START_STR
	int	21h

	;  DSP
	call	DspReset
	jc	no_sb

	mov	ah, 9
	mov	dx, SB_FOUND
	int	21h

	;   DSP
	mov	bx, DSP_ver
	dsp_w	[sbport], 0E1h, err
 .read:
	dsp_r	[sbport], err
	mov	[bx], al
	inc	bx
	cmp	bx, DSP_ver+1
	jbe	.read

	;  
	mov	ah, 9
	mov	dx, VERSION
	int	21h

	mov	ah, 2
	mov	dx, [DSP_ver]
	add	dl, 30h
	int	21h
	mov	dl, '.'
	int	21h
	mov	dl, dh
	add	dl, 30h
	int	21h

	jmp	prog_end

 no_sb:
	mov	ah, 9
	mov	dx, SB_NOT_FOUND
	int	21h
	jmp	prog_end

 err:
	mov	ah, 9
	mov	dx, SOME_ERR
	int	21h

 prog_end:
	;     
	mov	ah, 8
	int	21h
 ret

 ;---------------------------------------------------

 DspReset:
 ;    DSP
	mov	dx, [sbport]
	add	dx, 6
	mov	al, 1
	out	dx, al

	;   ?
	mov	cx, 40
 @@:
	in	al, dx
	loop	@b

	;  ,  
	mov	al, 0
	out	dx, al

	; ,   DSP
	dsp_r	[sbport], .no_sb
	cmp	al, 0AAh
	jnz	.no_sb

	;  DSP 
	clc	   ; CF = 0
	ret

 .no_sb:
	;  DSP  
	stc	   ; CF = 1
	ret
 ;----------------------------------------------------

 sbport 	dw 220h
 DSP_ver	dw 0
 START_STR	db 'Program started, initialisig SB...',13,10,'$'
 SB_NOT_FOUND:	db ':-( NO '
 SB_FOUND	db 'SB has been found!',13,10,'$'
 VERSION	db 'Version $'
 SOME_ERR	db 'Some error...',13,10,'$'
